
/* we are always concerned with 4 variables, in either conserved or
   primitive form */
#define NVAR 4

/* conserved */
#define DENS 0
#define XMOM 1
#define YMOM 2
#define ENER 3

/* primitive -- DENS is still 0 */
#define XVEL 1
#define YVEL 2
#define PRES 3


int _states(int idir, int nx, int ny, int ng, int nspecies,
            double gamma, double dtdx,
            double **r, double **u, double **v, double **p, double ***xn,
            double **ldr, double **ldu, double **ldv, double **ldp, double ***ldxn,
            double **r_xl, double **r_xr,
            double **u_xl, double **u_xr,
            double **v_xl, double **v_xr,
            double **p_xl, double **p_xr,
            double ***xn_xl, double ***xn_xr);


int _unsplitFluxes(int nx, int ny, int ng, int nspecies,
                   double dt, double dx, double dy,
		   double cvisc,
                   double gamma, double grav,
                   double **dens, double **xmom, double **ymom, double **ener,
                   double ***species,
                   double ***F_x, double ***F_y);

int _splitFluxes(int idir, int nx, int ny, int ng, int nspecies,
		 double dt, double dx, double dy,
		 double gamma, double grav,
		 double **dens, double **xmom, double **ymom, double **ener,
		 double ***species,
		 double ***F);

/* datatype for the wave region in the Riemann problem */
typedef enum {LEFT=1, STAR_LEFT, STAR_RIGHT, RIGHT} waveRegion_t;

/* datatype for the wave type */
typedef enum {RAREFACTION=1, CONTACT, SHOCK} waveType_t;

int consFluxX(double gamma, double U[], double Flux[]);
int consFluxY(double gamma, double U[], double Flux[]);

int _HLLC(int idir, int nx, int ny, int ng,
          double gamma,
          double **r_l, double **px_l, double **py_l, double **E_l,
          double **r_r, double **px_r, double **py_r, double **E_r,
          double **F_r, double **F_px, double **F_py, double **F_E);

int artifical_viscosity(int nx, int ny, int ng,
                        double cvisc,
                        double dx, double dy,
                        double **u, double **v,
                        double **avisco_x, double **avisco_y);

