pro radialbin, x, y, data, XCTR=xctr, YCTR=yctr, BINCENTERS=rBinCenters, VAR=varbin

s = size(data[*,*])
print, s
nx = s[1]
ny = s[2]

x2d = x # replicate(1., ny)
y2d = replicate(1., nx) # y

r = sqrt((x2d - xctr)^2 + (y2d - yctr)^2)

; put the radial distances and variable into a 1-d array
r1d = reform(r, nx*ny)
var1d = reform(data[*,*], nx*ny)

; create the radial bins
nbins = (floor(sqrt((nx/2)^2 + (ny/2)^2)) + 1)/2

rmin = 0.0
rmax = max(r1d)

dr = (rmax - rmin)/float(nbins)

rBinEdge = (findgen(nbins+1))*dr + rmin

rBinCenters = 0.5*(rBinEdge - shift(rBinEdge,1)) + shift(rBinEdge,1)
rBinCenters = rBinCenters[1:*]

varBin = fltarr(nbins)
varBin[*] = 0.0

binCount = lonarr(nbins)
binCount[*] = 0

; do the binning -- start by sorting data in r order
indexSorted = sort(r1d)

r1d = temporary(r1d[indexSorted])
var1d = temporary(var1d[indexSorted])

oldIndex = (where(r1d GT rBinEdge[0]))[0]

for i = 0l, nbins-1 do begin

    index = (where(r1d[oldIndex:*] GT rBinEdge[i+1]))[0]

; if index = -1, then there are no radial values larger than the
; current bin limit.
    if (index EQ -1) then begin
        varBin[i] = total(var1d[oldIndex:(size(r1d))[1]-1])
        binCount[i] = (size(r1d))[1] - oldIndex
        if (i LT nbins-1) then varBin[i+1:*] = 0.
        goto, break_point
    endif

    varBin[i] = total(var1d[oldIndex:oldIndex+index])
    binCount[i] = index

    oldIndex = oldIndex + index
endfor

break_point: print, 'done binning'

for i = 0l, nbins-1 do begin

    if (binCount[i] NE 0) then varBin[i] = varBin[i]/binCount[i]

endfor

end
