#!/usr/bin/env python
from io import *
from mesh import *
from util import compare
"""

test out the mesh class -- specifically the restriction and prolongation
routines

read in a test suite file and create two new instances of the mesh --
one restricted and one prolonged, storing each in a separate file

"""

print "loading the test file...\n"
testFile = "test/quad_unsplit_0148"

# read in the old file
myPatch = io.readFile(testFile)
print myPatch
myPatch.fillBC()


# restrict this data onto a new mesh
print " "
print 75*"X"
print "Restriction Test"
print 75*"X"

restrictPatch = myPatch.restrict()
print restrictPatch
io.writeFile("restrict.test", restrictPatch)

#load the benchmark restricted version and compare
testFile = "test/restrict.test"
testPatch = io.readFile(testFile)

print "comparing current solution to " + testFile

compare.mesh2d(restrictPatch,testPatch)            

# prolong the data onto a new mesh
print " "
print " "
print 75*"X"
print "Prolongation Test"
print 75*"X"

prolongPatch = myPatch.prolong()
print prolongPatch
io.writeFile("prolong.test", prolongPatch)

#load the benchmark restricted version and compare
testFile = "test/prolong.test"
testPatch = io.readFile(testFile)

print "comparing current solution to " + testFile

compare.mesh2d(prolongPatch,testPatch)            
