"""
  ---------------------------------------------------------------------
  Copyright (C) 2003, 2004  Michael Zingale

  This software is distributed under the terms of the GNU General
  Public License, version 2.  See COPYING for details.  It is covered
  by no warantee whatsoever, explicit or implied.
  ---------------------------------------------------------------------
"""


import sys
from util import runparams
from mesh import *
from numarray import *

def fillPatch(myPatch):
    """ initialize the smooth advection problem """

    print "initializing the smooth advection problem..."

    # make sure that we are passed a valid patch object
    if not isinstance(myPatch, patch.cellCentered):
        print "ERROR: patch invalid in io.dumpPatch()"
        print myPatch.__class__
        sys.exit()

    dens = myPatch.getVar("density")

    xmin = runparams.getParam("mesh.xmin")
    xmax = runparams.getParam("mesh.xmax")

    ymin = runparams.getParam("mesh.ymin")
    ymax = runparams.getParam("mesh.ymax")

    xctr = 0.5*(xmin + xmax)
    yctr = 0.5*(ymin + ymax)
    
    i = myPatch.imin
    while i <= myPatch.imax:

        j = myPatch.jmin
        while j <= myPatch.jmax:

            dens[i,j] = exp(-60.0*((myPatch.x[i]-xctr)**2 + \
                                   (myPatch.y[j]-yctr)**2))
                    
            j += 1
        i += 1
    

    
                             
