def mesh2d(A, B):
    """ compare mesh objects A and B, including the individual variables.
        here, A is assumed to be the new mesh object and B is the
        benchmark we are comparing to. """

    print 75*"="
    
    errors = 0

    if A.time != B.time:
        print "ERROR: simulation times do not match: ", A.time, B.time
        errors += 1
    else:
        print "simulation times match"


    if A.nstep != B.nstep:
        print "ERROR: number of steps do not match: ", A.nstep, B.nstep
        errors += 1
    else:
        print "number of steps match"
    

    if A.nx != B.nx or A.ny != B.ny or \
           A.xmin != B.xmin or A.xmax != B.xmax or \
           A.ymin != B.ymin or A.ymax != B.ymax:
        print "ERROR: grids do not match"
        print "current grid: nx = %d, ny = %d" % (A.nx, A.ny)
        print "              xmin = %d, xmax = %d" % (A.xmin, myPatch.xmax)
        print "              ymin = %d, ymax = %d" % (A.ymin, myPatch.ymax)
        print "benchmark grid: nx = %d, ny = %d" % (B.nx, B.ny)
        print "                xmin = %d, xmax = %d" % (B.xmin, B.xmax)
        print "                ymin = %d, ymax = %d" % (B.ymin, B.ymax)
        print " "
        errors += 1
        sys.exit(2)
    else:
        print "simulation grids match"
        
    print 75*"-"
        
    if A.vars != B.vars:
        print "ERROR: variables do not match"
        sys.exit(2)
    else:
        print "variable lists match"
        
            
    for var in A.vars:
        currentVar = A.getVar(var)
        benchVar = B.getVar(var)
                
        err = abs(currentVar[A.imin:A.imax+1,
                             A.jmin:A.jmax+1] -
                  benchVar[B.imin:B.imax+1,
                           B.jmin:B.jmax+1])
        print "variable: %s, maximum error = %13.6g" % (var, err.max())
        if err.max() != 0:
            errors += 1
                    
    print 75*"-"
                    
    if errors > 0:
        print 'comparison FAILED (%d errors)' % (errors)
    else:
        print 'comparison PASSED (%d errors)' % (errors)

    print 75*"="


                                                                                                                    
